;nyquist plug-in
;version 3
;type analyze
;name "Sample Data Export..."
;action "Processing..."
;info "by Steve Daulton. GPL v2."

;control funct "Select Function" choice "Reset,Write File,Show Path,View Help 1,View Help 2" 0
;control number-of-samples "Number of samples to measure" int "[integer]" 100 1 1000
;control write-mode "Write Mode" choice "Append,Overwrite" 0
;control type "File Type" choice "Data List (TXT),Indexed List (TXT),Data (CSV),Indexed (CSV),Extended (HTML)" 0
;control filename "Base File Name" string "" "sample-data"
;control location "Select Output Path" choice "Home Folder,Append to Home,Fully Defined Path" 0
;control path "Output Folder" string "[Use forward slashes]"  

(setq fxname 'Sample_Data_Export_26-01-2011_4:42b)
(setq msg "")

(defun help1 ()
   (format nil
"Select Function:
Reset: Resets the track counter.
Write File: Writes sample data to file.
Show Path: View the file path that will be used.
View Help: See this help file,\n
Number of samples to measure: 
Up to this number of samples will be analyzed,
starting from the beginning of the selection.
WARNING - Selecting over 1000 samples may crash
your computer. The maximum number of samples that
may be processed depends on the available RAM.\n
Write Mode:
Append: If the output file already exists, data
will bee added to the end of the file.
Overwrite:If the specified file exists it will be
overwritten. If multiple tracks are selected,
numbered files will be created using the specified
file name.
"))
(defun help2 ()
   (format nil
"File Type:
Data List (TXT): a plain text file with a list of
sample values.
Indexed List (TXT): Includes the sample number,
with count starting at 1.
Data (CSV):sample values separated by commas.
Indexed (CSV): sample number and sample value, 
comma separated list.
Extended HTML: HTML file with additional data.\n
Base File Name:
In 'Append' mode, this file name will be used 
with the appropriate extension (txt, csv or html).
In 'Overwrite' mode, each track processed will
produce a numbered file begining with this name. 
For example 'sample-data-01.txt'.
Use the 'Reset' button to reset the file number.\n
Output Path:
Home folder: Depends on operating system. Use 
'show path' function to check.
Append to Home: appends 'Output Folder' text to
the home folder path.
Fully Defined path: Uses text in the 'Output Folder
text box.
The output folder must exist and must be writable.
Use forward slashes '/' as the delimiting character
for example C:/Users/username.
"))

(defun view-help (num)
  (case num
  (3 (format t (help1))(format nil (help1)))
  (4 (format t (help2))(format nil (help2)))))

(defun home()
   (or (get-env "HOME")(get-env "UserProfile")))

(setq path
   (case location
      (0 (home))
      (1 (strcat (home) path))
      (2 path)))
      
(setdir path)

(if (or (= funct 0)(= (length msg) 0))
   (progn
      (setq filename (strcat filename 
        (case type
          (0 ".txt")
          (1 ".txt")
          (2 ".csv")
          (3 ".csv")
          (4 ".html"))))
      
      (case funct
         (0 (remprop '*scratch* fxname)
            (print "Track / File counter has been reset."))
         (1 (if (get '*scratch* fxname)
            (putprop '*scratch* (1+ (get '*scratch* fxname)) fxname)
            (putprop '*scratch* 0 fxname))
            (format nil "Data written to ~a\/~a~%" path filename))
         (2 (print (setdir ".")))
         (T (view-help funct))))
         
   (print msg))


